123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957 |
- #!/bin/bash
- OS_FOUND=$( command -v uname)
- case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
- linux*)
- TARGET_OS="linux"
- ;;
- msys*|cygwin*|mingw*)
-
- TARGET_OS='windows'
- ;;
- nt|win*)
- TARGET_OS='windows'
- ;;
- *)
- TARGET_OS='unknown'
- ;;
- esac
- if [ $TARGET_OS == "windows" ]; then
- if [ $(uname -m) == "x86_64" ]; then
- echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
- Processor="64"
- elif [ $(uname -m) == "i386" ]; then
- echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
- Processor="32"
- else
- echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
- echo "Please refer to the notes of build.sh$(tput sgr0)"
- exit 1
- fi
- elif [ $TARGET_OS == "linux" ]; then
- if [ $(uname -m) == "x86_64" ]; then
- echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
- Processor="64"
- elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
- echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
- Processor="32"
- else
- echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
- echo "Please refer to the notes of build.sh$(tput sgr0)"
- exit 1
- fi
- else
- echo "$(tput setaf 1)This script doesn't support your Operating system!"
- echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
- echo "Read the notes of build.sh$(tput sgr0)"
- exit 1
- fi
- sleep 2
- if ! type wget > /dev/null; then
- echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
- echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
- exit 2
- fi
- if ! type zip > /dev/null; then
- if [ $TARGET_OS == "windows" ]; then
- echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
- echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
- echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
- echo "Run git Bash under Administrator privilege and"
- echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
- echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
- exit 3
- elif [ $TARGET_OS == "linux" ]; then
- echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
- echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
-
- exit 3
- fi
- fi
- if ! type python > /dev/null; then
- if [ $TARGET_OS == "windows" ]; then
- echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
- exit 4
- elif [ $TARGET_OS == "linux" ]; then
- echo "$(tput setaf 1)Missing 'python' which is important to run this script"
- echo "As Python 2.x will not be maintained from 2020 please,"
- echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
- echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
- echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
-
- exit 4
- fi
- fi
- if ! type gawk > /dev/null; then
- if [ $TARGET_OS == "linux" ]; then
- echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
- echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
-
- exit 5
- fi
- fi
- ARDUINO_ENV="1.8.5"
- BUILD_ENV="1.0.6"
- BOARD="prusa_einsy_rambo"
- BOARD_PACKAGE_NAME="PrusaResearch"
- BOARD_VERSION="1.0.3"
- BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
- BOARD_FILENAME="prusa3dboards"
- BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
- PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
- LIB="PrusaLibrary"
- SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
- # List few useful data
- echo
- echo "Script path :" $SCRIPT_PATH
- echo "OS :" $OS
- echo "OS type :" $TARGET_OS
- echo ""
- echo "Arduino IDE :" $ARDUINO_ENV
- echo "Build env :" $BUILD_ENV
- echo "Board :" $BOARD
- echo "Package name:" $BOARD_PACKAGE_NAME
- echo "Board v. :" $BOARD_VERSION
- echo "Specific Lib:" $LIB
- echo ""
- #### Start prepare building environment
- #Check if build exists and creates it if not
- if [ ! -d "../PF-build-dl" ]; then
- mkdir ../PF-build-dl || exit 6
- fi
- cd ../PF-build-dl || exit 7
- BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
- # Check if PF-build-env-<version> exists and downloads + creates it if not
- # The build environment is based on the supported Arduino IDE portable version with some changes
- if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
- echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
- mkdir ../PF-build-env-$BUILD_ENV
- sleep 5
- fi
- # Download and extract supported Arduino IDE depending on OS
- # Windows
- if [ $TARGET_OS == "windows" ]; then
- if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
- echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
- sleep 2
- wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
- echo "$(tput sgr 0)"
- fi
- if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
- echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
- sleep 2
- unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 8
- mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
- echo "
- echo "$(tput sgr0)"
- fi
- fi
- if [ $TARGET_OS == "linux" ]; then
- if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
- echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
- sleep 2
- wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
- echo "$(tput sgr 0)"
- fi
- if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
- echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
- sleep 2
- tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
- mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
- echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
- echo "$(tput sgr0)"
- fi
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
- fi
- if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
- echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
- sleep 2
- echo "update.check"
- sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "board"
- sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "editor.linenumbers"
- sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "boardsmanager.additional.urls"
- echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
- echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
- echo "$(tput sgr0)"
- fi
- if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
- echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
- sleep 2
- wget $BOARD_FILE_URL || exit 9
- fi
- if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
- echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
- sleep 2
- tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
- fi
- if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
- mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
- fi
-
- mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
- echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
- echo "$(tput sgr 0)"
- fi
- if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
- echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
- sleep 2
- wget $PF_BUILD_FILE_URL || exit 11
- echo "$(tput sgr 0)"
- fi
- if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
- echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
- sleep 2
- unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
- echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
- echo "$(tput sgr0)"
- fi
- if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
- echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
- echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
- sleep 2
- fi
- if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
- echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
- sleep 2
- echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
- sleep 2
- cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
- echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
- echo "$(tput sgr0)"
- fi
- if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
- echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
- echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
- echo "Script will not continue until this have been fixed $(tput setaf 2)"
- sleep 2
- echo "$(tput sgr0)"
- exit 13
- fi
- cd $SCRIPT_PATH
- if type git > /dev/null; then
- git_available="1"
- fi
- while getopts v:l:d:b:o:c:p:n:?h flag
- do
- case "${flag}" in
- v) variant_flag=${OPTARG};;
- l) language_flag=${OPTARG};;
- d) devel_flag=${OPTARG};;
- b) build_flag=${OPTARG};;
- o) output_flag=${OPTARG};;
- c) clean_flag=${OPTARG};;
- p) prusa_flag=${OPTARG};;
- n) new_build_flag=${OPTARG};;
- ?) help_flag=1;;
- h) help_flag=1;;
- esac
- done
- if [ "$help_flag" == "1" ] ; then
- echo "***************************************"
- echo "* PF-build.sh Version: 1.0.6-Build_33 *"
- echo "***************************************"
- echo "Arguments:"
- echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
- echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
- echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
- echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
- echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
- echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
- echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
- echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
- echo "$(tput setaf 2)-?$(tput sgr0) Help"
- echo "$(tput setaf 2)-h$(tput sgr0) Help"
- echo
- echo "Brief USAGE:"
- echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
- echo
- echo "Example:"
- echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
- echo " Will build all variants as multi language and final GOLD version"
- echo
- echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
- echo " Will build MK3S multi language final GOLD firmware "
- echo " with current commit count number and output extra information,"
- echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
- echo
- exit 14
- fi
- if [ -z "$variant_flag" ] ; then
-
- PS3="Select a variant: "
- while IFS= read -r -d $'\0' f; do
- options[i++]="$f"
- done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
- select opt in "${options[@]}" "All" "Quit"; do
- case $opt in
- *.h)
- VARIANT=$(basename "$opt" ".h")
- VARIANTS[i++]="$opt"
- break
- ;;
- "All")
- VARIANT="All"
- VARIANTS=${options[*]}
- break
- ;;
- "Quit")
- echo "You chose to stop"
- exit 20
- ;;
- *)
- echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
- ;;
- esac
- done
- else
- if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
- VARIANTS=$variant_flag
- elif [ "$variant_flag" == "All" ] ; then
- while IFS= read -r -d $'\0' f; do
- options[i++]="$f"
- done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
- VARIANT="All"
- VARIANTS=${options[*]}
- else
- echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
- echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
- ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
- echo "$(tput sgr0)"
- exit 21
- fi
- fi
- MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
- if [ -z "$language_flag" ] ; then
- PS3="Select a language: "
- echo
- echo "Which lang-build do you want?"
- select yn in "Multi languages" "English only"; do
- case $yn in
- "Multi languages")
- LANGUAGES="ALL"
- break
- ;;
- "English only")
- LANGUAGES="EN_ONLY"
- break
- ;;
- *)
- echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
- ;;
- esac
- done
- else
- if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
- LANGUAGES=$language_flag
- else
- echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
- echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
- exit 22
- fi
- fi
- if [ ! -z "$devel_flag" ] ; then
- if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
- DEV_STATUS_SELECTED=$devel_flag
- else
- echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
- echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
- exit 23
- fi
- fi
- if [ ! -z "$build_flag" ] ; then
- if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
- echo "Build changed to $build_flag"
- BUILD=$(git rev-list --count HEAD)
- elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
- BUILD=$build_flag
- else
- echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
- echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
- exit 24
- fi
- echo "New Build number is: $BUILD"
- fi
- if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
- OUTPUT=1
- else
- OUTPUT=0
- fi
- if [ ! -z "git_available" ]; then
- BRANCH=""
- CLEAN_PF_FW_BUILD=0
- else
- BRANCH=$(git branch --show-current)
- echo "Current branch is:" $BRANCH
- if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
- echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
- echo "created PF-build.branch file"
- else
- PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
- echo "Previous branch was:" $PRE_BRANCH
- if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
- CLEAN_PF_FW_BUILD=1
- echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
- fi
- fi
- fi
- cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
- BUILD_ENV_PATH="$( pwd -P )"
- cd ../..
- if [ ! -d "Prusa-Firmware-build" ]; then
- mkdir Prusa-Firmware-build || exit 26
- fi
- cd Prusa-Firmware-build || exit 27
- BUILD_PATH="$( pwd -P )"
- if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
- read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
- rm -r *
- else
- echo "Nothing to clean up"
- fi
- for v in ${VARIANTS[*]}
- do
- VARIANT=$(basename "$v" ".h")
-
- FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
- if [ -z "$BUILD" ] ; then
-
- BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
- else
-
- BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
- echo "Original build number: $BUILD_ORG"
- sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
- fi
-
- MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
-
- DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
- if [ -z "$DEV_STATUS_SELECTED" ] ; then
- if [[ "$DEV_CHECK" == *"RC"* ]] ; then
- DEV_STATUS="RC"
- elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
- DEV_STATUS="ALPHA"
- elif [[ "$DEV_CHECK" == "BETA" ]]; then
- DEV_STATUS="BETA"
- elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
- DEV_STATUS="DEVEL"
- elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
- DEV_STATUS="DEBUG"
- else
- DEV_STATUS="UNKNOWN"
- echo
- echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
- PS3="Select YES only if source code is tested and trusted: "
- select yn in "Yes" "No"; do
- case $yn in
- Yes)
- DEV_STATUS="GOLD"
- DEV_STATUS_SELECTED="GOLD"
- break
- ;;
- No)
- DEV_STATUS="UNKNOWN"
- DEV_STATUS_SELECTED="UNKNOWN"
- break
- ;;
- *)
- echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
- ;;
- esac
- done
- fi
- else
- DEV_STATUS=$DEV_STATUS_SELECTED
- fi
-
- if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
- mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
- fi
- OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
-
-
- if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
- echo ""
- ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
- echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- read -t 10 -p "Press Enter to continue..."
- fi
- elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
- echo ""
- ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
- echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- read -t 10 -p "Press Enter to continue..."
- fi
- fi
- if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
- echo ""
- ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
- echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- read -t 10 -p "Press Enter to continue..."
- fi
- fi
-
-
- echo "$(tput setaf 2)$(tput setab 7) "
- echo "Variant :" $VARIANT
- echo "Firmware :" $FW
- echo "Build # :" $BUILD
- echo "Dev Check :" $DEV_CHECK
- echo "DEV Status :" $DEV_STATUS
- echo "Motherboard:" $MOTHERBOARD
- echo "Languages :" $LANGUAGES
- echo "Hex-file Folder:" $OUTPUT_FOLDER
- echo "$(tput sgr0)"
-
- if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
- cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
- else
- echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- read -t 10 -p "Press Enter to continue..."
- fi
- cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
- fi
-
- sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
-
- sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
-
- if [ $LANGUAGES == "EN_ONLY" ]; then
- echo " "
- echo "English only language firmware will be built"
- sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
- echo " "
- else
- echo " "
- echo "Multi-language firmware will be built"
- sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
- echo " "
- fi
-
-
-
-
-
-
-
- export ARDUINO=$BUILD_ENV_PATH
-
-
- echo
-
- echo
- echo "Start to build Prusa Firmware ..."
- echo "Using variant $VARIANT$(tput setaf 3)"
- if [ $OUTPUT == "1" ] ; then
- sleep 2
- fi
-
- if [ "$new_build_flag" == "1" ]; then
- rm -r -f $BUILD_PATH/* || exit 36
- fi
-
- $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
- echo "$(tput sgr 0)"
- if [ $LANGUAGES == "ALL" ]; then
- echo "$(tput setaf 2)"
- echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
- echo "$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- sleep 2
- fi
- cd $SCRIPT_PATH/lang
- echo "$(tput setaf 3)"
- ./config.sh || exit 31
- echo "$(tput sgr 0)"
-
- if [ -f "lang_en.tmp" ]; then
- echo ""
- echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- read -t 10 -p "Press Enter to continue..."
- fi
- echo "$(tput setaf 3)"
- ./lang-clean.sh
- echo "$(tput sgr 0)"
- fi
- if [ -f "progmem.out" ]; then
- echo ""
- echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
- if [ $OUTPUT == "1" ] ; then
- read -t 10 -p "Press Enter to continue..."
- fi
- echo "$(tput setaf 3)"
- ./fw-clean.sh
- echo "$(tput sgr 0)"
- fi
-
- echo "$(tput setaf 3)"
- ./lang-build.sh || exit 32
-
- ./lang-community.sh || exit 33
-
- ./fw-build.sh || exit 34
- cp not_tran.txt not_tran_$VARIANT.txt
- cp not_used.txt not_used_$VARIANT.txt
- echo "$(tput sgr 0)"
-
- MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
-
- if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
- echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
- cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
- else
- echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
- cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
- cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
- cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
- cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
- cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
- cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
- cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
- if [ $TARGET_OS == "windows" ]; then
- zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
- rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
- elif [ $TARGET_OS == "linux" ]; then
- zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
- fi
- fi
-
- if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
- echo "$(tput setaf 3)"
- ./fw-clean.sh || exit 35
- ./lang-clean.sh || exit 36
- echo "$(tput sgr 0)"
- fi
- else
- echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
- cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 37
- fi
-
- if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
- rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 38
- fi
- if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
- then
- rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
- fi
- if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
- then
- rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
- fi
- if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
- then
- rm $SCRIPT_PATH/lang/not_tran.txt
- fi
- if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
- then
- rm $SCRIPT_PATH/lang/not_used.txt
- fi
-
- if [ "$new_build_flag" == "1" ]; then
- rm -r -f $BUILD_PATH/* || exit 39
- fi
-
- sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
- sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
- if [ ! -z "$BUILD_ORG" ] ; then
- sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
- fi
- echo $MULTI_LANGUAGE_CHECK
-
- sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
- sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
- if [ $OUTPUT == "1" ] ; then
- sleep 5
- fi
- done
- cd $SCRIPT_PATH
- cd ..
- echo "$(tput setaf 2) "
- echo " "
- echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
- echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
|